package org.bdware.sc.controlproxy;

import com.google.gson.*;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bdware.doip.audit.EndpointConfig;
import org.bdware.doip.audit.SM2Signer;
import org.bdware.doip.audit.client.AuditDoipClient;
import org.bdware.doip.audit.client.AuditIrpClient;
import org.bdware.doip.audit.config.TempConfigStorage;
import org.bdware.doip.audit.writer.AuditConfig;
import org.bdware.doip.audit.writer.AuditType;
import org.bdware.doip.auditrepo.AutoAuditDO;
import org.bdware.doip.codec.doipMessage.DoipMessage;
import org.bdware.doip.endpoint.client.ClientConfig;
import org.bdware.irp.stateinfo.StateInfoBase;
import org.bdware.sc.engine.JSONTool;


public class RepoProxy {
    private static final Logger LOGGER = LogManager.getLogger(RepoProxy.class);

    public static void main(String[] args) {
        LOGGER.info("abc");
    }

    static String prefix;
    public static String router;
    static EndpointConfig endpointConfig;

    public static void init(Object obj) {
        if (obj == null) {
            return;
        }
        if (obj instanceof String) {
            if (!((String) obj).startsWith("{")) {

            }
            TempConfigStorage storage = new TempConfigStorage((String) obj);
            endpointConfig = storage.loadAsEndpointConfig();
            prefix = storage.load().get("prefix").getAsString();
            router = storage.load().get("router").getAsString();
        } else {
            JsonElement je = JSONTool.convertMirrorToJson(obj);
            TempConfigStorage storage = new TempConfigStorage(je.toString());
            endpointConfig = storage.loadAsEndpointConfig();
            prefix = storage.load().get("prefix").getAsString();

           router = storage.load().get("router").getAsString();

        }
    }

    public static String getConfig() {
        return new Gson().toJson(endpointConfig);
    }

    public static String call() {
        return "hello..dafdskf";
    }

    public static JsonElement getDoAuditRule(Object obj) {
        JsonObject jo = JSONTool.convertMirrorToJson(obj).getAsJsonObject();
        String doId = jo.get("doId").getAsString();
        if (!doId.contains("/")) {
            doId = prefix + "/" + doId;
        }
        ClientConfig config = null;
        AuditType type = null;
        try {
            AuditIrpClient irpClient = new AuditIrpClient(endpointConfig);
            AuditConfig auditConfig = irpClient.getAuditConfig();
            AuditDoipClient client = new AuditDoipClient(auditConfig, new SM2Signer(null));
            StateInfoBase result = irpClient.resolve(doId);
            config = new ClientConfig(result.getValues("address"));
            client.connect(config);
            DoipMessage msg = client.sendMessageSync(AutoAuditDO.getRepoAuditType(doId));
            type = AutoAuditDO.getAuditTypeFromRespMessage(msg);
            LOGGER.info(type);
        } catch (Exception e) {
            e.printStackTrace();
        }

        JsonObject ret = new JsonObject();
        ret.addProperty("total", 1);
        JsonArray jsonArray = new JsonArray();
        ret.add("data", jsonArray);
        String format = "{\"doId\":\"%s\",\"auditRule\":{\"type\":%d}}";
        if (type == null) {
            jsonArray.add(JsonParser.parseString(String.format(format, "不可配置：" + doId, 0)));
        } else
            jsonArray.add(JsonParser.parseString(String.format(format, doId, type.ordinal())));
        return ret;
    }

}